<!DOCTYPE html>
<meta charset="utf-8">
<style>

body {
  font: 10px sans-serif;
}

.axis path,
.axis line {
  fill: none;
  stroke: #000;
  shape-rendering: crispEdges;
}

.x.axis path {
  display: none;
}

.line {
  fill: none;
  stroke: red;
  stroke-width: 1.5px;
}

</style>
<body>
 <script src="d3.min.js"></script> 



<?php
//Identify requested file
$datfiles = glob('*.{dat}', GLOB_BRACE);
if ($_GET["f"]>=0 and $_GET["f"]<sizeof($datfiles)) {
	$reqdfile=$datfiles[$_GET["f"]];
} else {
	$reqdfile=$datfiles[count($datfiles)-1];
}
?>
 
<script>


var margin = {top: 40, right: 20, bottom: 30, left: 50},
    width = 960 - margin.left - margin.right,
    height = 350 - margin.top - margin.bottom;

//Format time string from UTC datestamp in .dat file
var parseDate = d3.time.format.utc("%Y-%m-%dT%H:%M:%S.%L").parse;

var x = d3.time.scale()
    .range([0, width]);

var y = d3.scale.linear()
    .range([height, 0]);

var xAxis = d3.svg.axis()
    .scale(x)
    .orient("bottom");

var yAxis = d3.svg.axis()
    .scale(y)
    .orient("left");

var line = d3.svg.line()
    .x(function(d) { return x(d.date); })
    .y(function(d) { return y(d.MSAS); });

var svg = d3.select("body").append("svg")
    .attr("width", width + margin.left + margin.right)
    .attr("height", height + margin.top + margin.bottom)
    .append("g")
    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");


// Define delimeter separated variables
var dsv = d3.dsv(";", "text/plain");

// Define header separated variables
var hsv = d3.dsv(":", "text/plain");

var FieldHeaders="";
var counter=0;


//Indicate that file has not yet been read.
<?php $fileread=0; ?>


// Parse header
d3.text("<?php echo($reqdfile); ?>", 'text/csv', function(hfile) {

  <?php $fileread=1; ?>

  //Remove non-comment lines
  hfile = hfile.replace(/^[^#][^\r\n]+[\r\n]+/mg, "");
  
  //Split lines into array elements
  res = hfile.split("\n");
  
  res.forEach(function(d) {

  //Title
    if(d.indexOf("# Instrument ID:")>-1) {
	InstID = d.split(":");
	svg.append("text")
        .attr("x", (width / 2))             
        .attr("y", 0 - (margin.top / 2))
        .attr("text-anchor", "middle")  
        .style("font-size", "16px") 
        .style("text-decoration", "underline")  
        .text(InstID[1]);	
	}
	
   //Model
//    if(d.indexOf("# Device type: SQM-LE")>-1) {
//      FieldType="SQM-LE";
//    }
    //Field headers
    if(d.indexOf("# UTC Date ")>-1) {
//         FieldHeaders = d.substr(2, d.length);
//         FieldHeaders = FieldHeaders.concat("\r\n");
         FieldHeaders ="UTC;Local;Temperature;Counts;Frequency;MSAS\r\n"
	}
  });
});
   
// Parse data
//*** There is a timescale problem with displaying a plot that only has one point
 d3.text("<?php echo($reqdfile); ?>", 'text/csv', function(csv) {
    <?php $fileread=1; ?>

  //Remove comment lines
  csv = csv.replace(/^[#][^\r\n]+[\r\n]+/mg, "");
  
  csv = FieldHeaders.concat(csv);
  
  data = dsv.parse(csv);

  data.forEach(function(d) {
    d.date = parseDate(d.UTC);
    d.MSAS = +d.MSAS;
    d.counter = counter++;
  });

  x.domain(d3.extent(data, function(d) { return d.date; }));
  y.domain(d3.extent(data, function(d) { return d.MSAS; }));

  svg.append("g")
      .attr("class", "x axis")
      .attr("transform", "translate(0," + height + ")")
      .call(xAxis);

  //Y axis label
  svg.append("g")
      .attr("class", "y axis")
      .call(yAxis)
      .append("text")
      .attr("transform", "rotate(-90)")
      .attr("y", 6)
      .attr("dy", "-3em")
      .style("text-anchor", "middle")
      .text("MPSAS");
        
  svg.append("path")
      .datum(data)
      .attr("class", "line")
      .attr("d", line);

});


//Show links to other dat files for selection.
document.write('<?php 
	echo '<br>';
	for ($i=0; $i<sizeof($datfiles); $i++) {
		echo '<a href="index.php?f=', $i, '">', $datfiles[$i], '</a>';
		if ($i==$_GET["f"]) echo ' <';
		echo '<br>';
	}
?><br>');

//Indicate that the file has been parsed.
// document.write('<?php 
// 	echo '<br> fileread=';
// 	if ($fileread==1) {echo '1'; }else{echo '0';}
// ?><br>');


</script>


